import { useRef, useState, useCallback, useEffect, createContext, useContext, createElement } from 'react';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var isCheckBoxInput = (function (type) { return type === 'checkbox'; });

function attachEventListeners(_a) {
    var field = _a.field, validateAndStateUpdate = _a.validateAndStateUpdate, isRadio = _a.isRadio;
    var ref = field.ref;
    if (!ref.addEventListener)
        return;
    ref.addEventListener(isCheckBoxInput(ref.type) || isRadio ? 'change' : 'input', validateAndStateUpdate);
    ref.addEventListener('blur', validateAndStateUpdate);
}

var isObject = (function (value) {
    return value !== null && !Array.isArray(value) && typeof value === 'object';
});

var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
var reIsPlainProp = /^\w*$/;
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var reIsUint = /^(?:0|[1-9]\d*)$/;
var isArray = Array.isArray;
function isIndex(value) {
    return reIsUint.test(value) && value > -1;
}
function isKey(value) {
    if (isArray(value))
        return false;
    return reIsPlainProp.test(value) || !reIsDeepProp.test(value);
}
var stringToPath = function (string) {
    var result = [];
    string.replace(rePropName, function (match, number, quote, string) {
        result.push(quote ? string.replace(reEscapeChar, '$1') : number || match);
    });
    return result;
};
function set(object, path, value) {
    path = isKey(path) ? [path] : stringToPath(path);
    var index = -1;
    var length = path.length;
    var lastIndex = length - 1;
    while (++index < length) {
        var key = path[index];
        var newValue = value;
        if (index !== lastIndex) {
            var objValue = object[key];
            newValue =
                isObject(objValue) || isArray(objValue)
                    ? objValue
                    : isIndex(path[index + 1])
                        ? []
                        : {};
        }
        object[key] = newValue;
        object = object[key];
    }
    return object;
}

var combineFieldValues = (function (data) {
    return Object.entries(data).reduce(function (previous, _a) {
        var _b = __read(_a, 2), key = _b[0], value = _b[1];
        if (key.match(/\[\d+\]/gi) || key.indexOf('.')) {
            set(previous, key, value);
            return previous;
        }
        previous[key] = value;
        return previous;
    }, {});
});

var removeAllEventListeners = (function (ref, validateWithStateUpdate) {
    if (!ref.removeEventListener)
        return;
    ref.removeEventListener('input', validateWithStateUpdate);
    ref.removeEventListener('change', validateWithStateUpdate);
    ref.removeEventListener('blur', validateWithStateUpdate);
});

var isRadioInput = (function (type) { return type === 'radio'; });

function findRemovedFieldAndRemoveListener(fields, touchedFieldsRef, fieldsWithValidationRef, validateWithStateUpdate, _a, forceDelete) {
    var ref = _a.ref, mutationWatcher = _a.mutationWatcher, options = _a.options;
    if (forceDelete === void 0) { forceDelete = false; }
    if (!ref || !ref.type)
        return;
    var name = ref.name, type = ref.type;
    var isRefDeleted = !document.body.contains(ref);
    touchedFieldsRef.current.delete(name);
    fieldsWithValidationRef.current.delete(name);
    if (isRadioInput(type) && options) {
        options.forEach(function (_a, index) {
            var ref = _a.ref;
            if (ref instanceof HTMLElement && isRefDeleted && options[index]) {
                removeAllEventListeners(options[index], validateWithStateUpdate);
                (options[index].mutationWatcher || { disconnect: function () { } }).disconnect();
                options.splice(index, 1);
            }
        });
        if (!options.length)
            delete fields[name];
    }
    else if ((ref instanceof HTMLElement && isRefDeleted) || forceDelete) {
        removeAllEventListeners(ref, validateWithStateUpdate);
        if (mutationWatcher)
            mutationWatcher.disconnect();
        delete fields[name];
    }
}

var defaultReturn = {
    isValid: false,
    value: '',
};
function getRadioValue(options) {
    return Array.isArray(options)
        ? options.reduce(function (previous, _a) {
            var _b = _a.ref, checked = _b.checked, value = _b.value;
            return checked
                ? {
                    isValid: true,
                    value: value,
                }
                : previous;
        }, defaultReturn)
        : defaultReturn;
}

var getMultipleSelectValue = (function (options) {
    return options.filter(function (_a) {
        var selected = _a.selected;
        return selected;
    }).map(function (_a) {
        var value = _a.value;
        return value;
    });
});

function getFieldValue(fields, _a) {
    var type = _a.type, name = _a.name, options = _a.options, checked = _a.checked, value = _a.value;
    if (isRadioInput(type)) {
        var field = fields[name];
        return field ? getRadioValue(field.options).value : '';
    }
    if (type === 'select-multiple')
        return getMultipleSelectValue(options);
    if (isCheckBoxInput(type))
        return checked ? value || checked : false;
    return value;
}

var isString = (function (value) { return typeof value === 'string'; });

function getFieldsValue(fields, fieldName) {
    return Object.values(fields).reduce(function (previous, _a) {
        var ref = _a.ref, name = _a.ref.name;
        var value = getFieldValue(fields, ref);
        if (isString(fieldName))
            return name === fieldName ? value : previous;
        if (!fieldName) {
            previous[name] = value;
        }
        else if (Array.isArray(fieldName) && fieldName.includes(name)) {
            previous[name] = value;
        }
        return previous;
    }, {});
}

var isEmptyObject = (function (value) {
    return isObject(value) && Object.keys(value).length === 0;
});

function shouldUpdateWithError(_a) {
    var errors = _a.errors, name = _a.name, error = _a.error, isOnBlur = _a.isOnBlur, isBlurType = _a.isBlurType, isValidateDisabled = _a.isValidateDisabled;
    if (isValidateDisabled ||
        (isOnBlur && !isBlurType) ||
        (isEmptyObject(error) && isEmptyObject(errors)) ||
        (errors[name] && errors[name].isManual)) {
        return false;
    }
    if ((isEmptyObject(errors) && !isEmptyObject(error)) ||
        (isEmptyObject(error) && errors[name]) ||
        !errors[name]) {
        return true;
    }
    return (errors[name] &&
        error[name] &&
        (errors[name].type !== error[name].type ||
            errors[name].message !== error[name].message));
}

var isUndefined = (function (val) { return val === undefined; });

var isNullOrUndefined = (function (value) {
    return value === null || isUndefined(value);
});

var getValueAndMessage = (function (item) { return ({
    value: isObject(item) && !isNullOrUndefined(item.value) ? item.value : item,
    message: isObject(item) && item.message ? item.message : '',
}); });

var displayNativeError = (function (nativeValidation, ref, message) {
    if (nativeValidation && isString(message))
        ref.setCustomValidity(message);
});

var DATE_INPUTS = ['date', 'time', 'month', 'datetime', 'datetime-local', 'week'];
var STRING_INPUTS = ['text', 'email', 'password', 'search', 'tel', 'url', 'textarea'];
var VALIDATION_MODE = {
    onBlur: 'onBlur',
    onchange: 'onChange',
    onSubmit: 'onSubmit',
};

var isFunction = (function (value) {
    return typeof value === 'function';
});

var isBoolean = (function (value) { return typeof value === 'boolean'; });

var _this = undefined;
var validateField = (function (_a, fields, nativeValidation) {
    var ref = _a.ref, _b = _a.ref, type = _b.type, value = _b.value, name = _b.name, checked = _b.checked, options = _a.options, required = _a.required, maxLength = _a.maxLength, minLength = _a.minLength, min = _a.min, max = _a.max, pattern = _a.pattern, validate = _a.validate;
    return __awaiter(_this, void 0, void 0, function () {
        var error, isRadio, isCheckBox, isSelectOrInput, nativeError, isStringInput, exceedMax, exceedMin, valueNumber, _c, maxValue, maxMessage, _d, minValue, minMessage, message, _e, maxLengthValue, maxLengthMessage, _f, minLengthValue, minLengthMessage, inputLength, exceedMax, exceedMin, message, _g, patternValue, patternMessage, fieldValue_1, validateRef_1, result, validationResult;
        var _this = this;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    error = {};
                    isRadio = isRadioInput(type);
                    isCheckBox = isCheckBoxInput(type);
                    isSelectOrInput = !isCheckBox && !isRadio;
                    nativeError = displayNativeError.bind(null, nativeValidation, ref);
                    isStringInput = STRING_INPUTS.includes(type);
                    if (required &&
                        ((isCheckBox && !checked) ||
                            (isSelectOrInput && value === '') ||
                            (isRadio && !getRadioValue(fields[name].options).isValid) ||
                            (!type && !value))) {
                        error[name] = {
                            type: 'required',
                            message: isString(required) ? required : '',
                            ref: isRadio ? (fields[name].options || [{ ref: '' }])[0].ref : ref,
                        };
                        nativeError(required);
                        return [2 /*return*/, error];
                    }
                    if ((!isNullOrUndefined(min) || !isNullOrUndefined(max)) && !isStringInput) {
                        exceedMax = void 0;
                        exceedMin = void 0;
                        valueNumber = parseFloat(value);
                        _c = getValueAndMessage(max), maxValue = _c.value, maxMessage = _c.message;
                        _d = getValueAndMessage(min), minValue = _d.value, minMessage = _d.message;
                        if (type === 'number') {
                            exceedMax = !isNullOrUndefined(maxValue) && valueNumber > maxValue;
                            exceedMin = !isNullOrUndefined(minValue) && valueNumber < minValue;
                        }
                        else if (DATE_INPUTS.includes(type)) {
                            if (isString(maxValue))
                                exceedMax = maxValue && new Date(value) > new Date(maxValue);
                            if (isString(minValue))
                                exceedMin = minValue && new Date(value) < new Date(minValue);
                        }
                        if (exceedMax || exceedMin) {
                            message = exceedMax ? maxMessage : minMessage;
                            error[name] = {
                                type: exceedMax ? 'max' : 'min',
                                message: message,
                                ref: ref,
                            };
                            nativeError(message);
                            return [2 /*return*/, error];
                        }
                    }
                    if ((maxLength || minLength) && isStringInput) {
                        _e = getValueAndMessage(maxLength), maxLengthValue = _e.value, maxLengthMessage = _e.message;
                        _f = getValueAndMessage(minLength), minLengthValue = _f.value, minLengthMessage = _f.message;
                        inputLength = value.toString().length;
                        exceedMax = maxLength && inputLength > maxLengthValue;
                        exceedMin = minLength && inputLength < minLengthValue;
                        message = exceedMax ? maxLengthMessage : minLengthMessage;
                        if (exceedMax || exceedMin) {
                            error[name] = {
                                type: exceedMax ? 'maxLength' : 'minLength',
                                message: message,
                                ref: ref,
                            };
                            nativeError(message);
                            return [2 /*return*/, error];
                        }
                    }
                    if (pattern) {
                        _g = getValueAndMessage(pattern), patternValue = _g.value, patternMessage = _g.message;
                        if (patternValue instanceof RegExp && !patternValue.test(value)) {
                            error[name] = {
                                type: 'pattern',
                                message: patternMessage,
                                ref: ref,
                            };
                            nativeError(patternMessage);
                            return [2 /*return*/, error];
                        }
                    }
                    if (!validate) return [3 /*break*/, 4];
                    fieldValue_1 = isRadio ? getRadioValue(options).value : value;
                    validateRef_1 = isRadio && options ? options[0].ref : ref;
                    if (!isFunction(validate)) return [3 /*break*/, 2];
                    return [4 /*yield*/, validate(fieldValue_1)];
                case 1:
                    result = _h.sent();
                    if ((isString(result) && result) || (isBoolean(result) && !result)) {
                        error[name] = {
                            type: 'validate',
                            message: isString(result) ? result : '',
                            ref: validateRef_1,
                        };
                        nativeError(result);
                        return [2 /*return*/, error];
                    }
                    return [3 /*break*/, 4];
                case 2:
                    if (!isObject(validate)) return [3 /*break*/, 4];
                    return [4 /*yield*/, new Promise(function (resolve) {
                            var values = Object.entries(validate);
                            values.reduce(function (previous, _a, index) {
                                var _b = __read(_a, 2), key = _b[0], validate = _b[1];
                                return __awaiter(_this, void 0, void 0, function () {
                                    var lastChild, result, message, data;
                                    return __generator(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                lastChild = values.length - 1 === index;
                                                if (!isFunction(validate)) return [3 /*break*/, 2];
                                                return [4 /*yield*/, validate(fieldValue_1)];
                                            case 1:
                                                result = _c.sent();
                                                if (!isBoolean(result) || !result) {
                                                    message = isString(result) ? result : '';
                                                    data = {
                                                        type: key,
                                                        message: message,
                                                        ref: validateRef_1,
                                                    };
                                                    nativeError(message);
                                                    return [2 /*return*/, lastChild ? resolve(data) : data];
                                                }
                                                _c.label = 2;
                                            case 2: return [2 /*return*/, lastChild ? resolve(previous) : previous];
                                        }
                                    });
                                });
                            }, {});
                        })];
                case 3:
                    validationResult = _h.sent();
                    if (validationResult && !isEmptyObject(validationResult)) {
                        error[name] = __assign({ ref: validateRef_1 }, validationResult);
                        return [2 /*return*/, error];
                    }
                    _h.label = 4;
                case 4:
                    if (nativeValidation)
                        ref.setCustomValidity('');
                    return [2 /*return*/, error];
            }
        });
    });
});

function parseErrorSchema(error) {
    return error.inner.reduce(function (previous, _a) {
        var _b;
        var path = _a.path, message = _a.message, type = _a.type;
        return (__assign({}, previous, (_b = {}, _b[path] = { message: message, ref: {}, type: type }, _b)));
    }, {});
}
function validateWithSchema(ValidationSchema, data) {
    return __awaiter(this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, ValidationSchema.validate(data, { abortEarly: false })];
                case 1:
                    _a.sent();
                    return [2 /*return*/, {}];
                case 2:
                    e_1 = _a.sent();
                    return [2 /*return*/, parseErrorSchema(e_1)];
                case 3: return [2 /*return*/];
            }
        });
    });
}

function attachNativeValidation(ref, rules) {
    Object.entries(rules).forEach(function (_a) {
        var _b = __read(_a, 2), key = _b[0], value = _b[1];
        if (key === 'required') {
            ref[key] = true;
        }
        else if (key === 'pattern' && value instanceof RegExp) {
            ref[key] = value.source;
        }
        else {
            ref[key] = value;
        }
    });
}

function onDomRemove(element, onDetachCallback) {
    var observer = new MutationObserver(function () {
        function isDetached(element) {
            if (!element || !element.parentNode)
                return true;
            if (element.parentNode === window.document) {
                return false;
            }
            else if (element.parentNode === null) {
                return true;
            }
            return isDetached(element.parentNode);
        }
        if (isDetached(element)) {
            observer.disconnect();
            onDetachCallback();
        }
    });
    observer.observe(window.document, {
        childList: true,
        subtree: true,
    });
    return observer;
}

var modeChecker = (function (mode) { return ({
    isOnSubmit: !mode || mode === VALIDATION_MODE.onSubmit,
    isOnBlur: mode === VALIDATION_MODE.onBlur,
    isOnChange: mode === VALIDATION_MODE.onchange,
}); });

var warnMessage = (function (message) {
    if (process.env.NODE_ENV !== 'production')
        console.warn(message);
});

function get(object, keys, defaultVal) {
    keys = Array.isArray(keys)
        ? keys
        : keys
            .replace(/\[/g, '.')
            .replace(/\]/g, '')
            .split('.');
    object = object[keys[0]];
    return object && keys.length > 1
        ? get(object, keys.slice(1), defaultVal)
        : isUndefined(object)
            ? defaultVal
            : object;
}

var getDefaultValue = (function (defaultValues, name) {
    return defaultValues && (defaultValues[name] || get(defaultValues, name));
});

function flatArray(list) {
    return list.reduce(function (a, b) { return a.concat(Array.isArray(b) ? flatArray(b) : b); }, []);
}

var getPath = function (path, values) {
    return Array.isArray(values)
        ? values.map(function (item, index) {
            var pathWithIndex = path + "[" + index + "]";
            if (Array.isArray(item)) {
                return getPath(pathWithIndex, item);
            }
            else if (isObject(item)) {
                return Object.entries(item).map(function (_a) {
                    var _b = __read(_a, 2), key = _b[0], objectValue = _b[1];
                    return isString(objectValue)
                        ? pathWithIndex + "." + key
                        : getPath(pathWithIndex + "." + key, objectValue);
                });
            }
            return pathWithIndex;
        })
        : Object.entries(values).map(function (_a) {
            var _b = __read(_a, 2), key = _b[0], objectValue = _b[1];
            return isString(objectValue) ? path + "." + key : getPath(path, objectValue);
        });
};
var getPath$1 = (function (parentPath, value) {
    return flatArray(getPath(parentPath, value));
});

var assignWatchFields = (function (fieldValues, fieldName, watchFields) {
    if (isEmptyObject(fieldValues) || isUndefined(fieldValues))
        return undefined;
    if (fieldValues[fieldName]) {
        watchFields[fieldName] = true;
        return fieldValues[fieldName];
    }
    var combinedValues = combineFieldValues(fieldValues);
    var values = get(combinedValues, fieldName);
    if (values !== undefined) {
        var result = getPath$1(fieldName, values);
        if (Array.isArray(result)) {
            result.forEach(function (name) {
                watchFields[name] = true;
            });
        }
    }
    return values;
});

function useForm(_a) {
    var _this = this;
    var _b = _a === void 0 ? {
        mode: 'onSubmit',
        defaultValues: {},
        nativeValidation: false,
        submitFocusError: true,
    } : _a, mode = _b.mode, validationSchema = _b.validationSchema, defaultValues = _b.defaultValues, validationFields = _b.validationFields, nativeValidation = _b.nativeValidation, submitFocusError = _b.submitFocusError;
    var fieldsRef = useRef({});
    var errorsRef = useRef({});
    var submitCountRef = useRef(0);
    var touchedFieldsRef = useRef(new Set());
    var watchFieldsRef = useRef({});
    var isUnMount = useRef(false);
    var isWatchAllRef = useRef(false);
    var isSubmittingRef = useRef(false);
    var isSubmittedRef = useRef(false);
    var isDirtyRef = useRef(false);
    var isSchemaValidateTriggeredRef = useRef(false);
    var validateAndStateUpdateRef = useRef();
    var fieldsWithValidationRef = useRef(new Set());
    var validFieldsRef = useRef(new Set());
    var _c = __read(useState({}), 2), _unused = _c[0], reRenderForm = _c[1];
    var _d = useRef(modeChecker(mode)).current, isOnChange = _d.isOnChange, isOnBlur = _d.isOnBlur, isOnSubmit = _d.isOnSubmit;
    var combineErrorsRef = function (data) { return (__assign({}, errorsRef.current, data)); };
    var renderBaseOnError = useCallback(function (name, errorsFromRef, error, shouldRender) {
        if (shouldRender === void 0) { shouldRender = true; }
        if (errorsFromRef[name] && !error[name]) {
            delete errorsRef.current[name];
            validFieldsRef.current.add(name);
            if (shouldRender)
                reRenderForm({});
            return true;
        }
        else if (error[name]) {
            validFieldsRef.current.delete(name);
            if (shouldRender)
                reRenderForm({});
            return true;
        }
        if (!isOnSubmit && !validFieldsRef.current.has(name)) {
            validFieldsRef.current.add(name);
            if (shouldRender)
                reRenderForm({});
            return true;
        }
        return false;
    }, [isOnSubmit]);
    var setFieldValue = function (name, value) {
        var field = fieldsRef.current[name];
        if (!field)
            return;
        var ref = field.ref;
        var options = field.options;
        if (isRadioInput(ref.type) && options) {
            options.forEach(function (_a) {
                var radioRef = _a.ref;
                if (radioRef.value === value)
                    radioRef.checked = true;
            });
        }
        else {
            ref[isCheckBoxInput(ref.type) ? 'checked' : 'value'] = value;
        }
    };
    var setValueInternal = useCallback(function (name, value) {
        setFieldValue(name, value);
        touchedFieldsRef.current.add(name);
        isDirtyRef.current = true;
        reRenderForm({});
    }, []);
    var executeValidation = useCallback(function (_a, shouldRender) {
        var name = _a.name, value = _a.value;
        if (shouldRender === void 0) { shouldRender = true; }
        return __awaiter(_this, void 0, void 0, function () {
            var field, errors, error;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        field = fieldsRef.current[name];
                        errors = errorsRef.current;
                        if (!field)
                            return [2 /*return*/, false];
                        if (value !== undefined)
                            setValueInternal(name, value);
                        return [4 /*yield*/, validateField(field, fieldsRef.current)];
                    case 1:
                        error = _b.sent();
                        errorsRef.current = combineErrorsRef(error);
                        renderBaseOnError(name, errors, error, shouldRender);
                        return [2 /*return*/, isEmptyObject(error)];
                }
            });
        });
    }, [renderBaseOnError, setValueInternal]);
    var executeSchemaValidation = useCallback(function (payload) { return __awaiter(_this, void 0, void 0, function () {
        var fieldValues, fieldErrors, result, errors, names_1, payloadName;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    fieldValues = getFieldsValue(fieldsRef.current);
                    return [4 /*yield*/, validateWithSchema(validationSchema, fieldValues)];
                case 1:
                    fieldErrors = _b.sent();
                    if (Array.isArray(payload)) {
                        names_1 = payload.map(function (_a) {
                            var name = _a.name;
                            return name;
                        });
                        errors = combineErrorsRef(Object.entries(fieldErrors).reduce(function (previous, _a) {
                            var _b;
                            var _c = __read(_a, 2), key = _c[0], value = _c[1];
                            return names_1.includes(key) ? __assign({}, previous, (_b = {}, _b[key] = value, _b)) : previous;
                        }, {}));
                        result = isEmptyObject(fieldErrors);
                    }
                    else {
                        payloadName = payload.name;
                        errors = combineErrorsRef(fieldErrors[payloadName] ? (_a = {}, _a[payloadName] = fieldErrors[payloadName], _a) : null);
                        result = !fieldErrors[payloadName];
                    }
                    errorsRef.current = errors;
                    isSchemaValidateTriggeredRef.current = true;
                    reRenderForm({});
                    return [2 /*return*/, result];
            }
        });
    }); }, [validationSchema]);
    var triggerValidation = useCallback(function (payload) { return __awaiter(_this, void 0, void 0, function () {
        var fields, result;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fields = payload;
                    if (!payload)
                        fields = Object.keys(fieldsRef.current).map(function (name) { return ({ name: name }); });
                    if (validationSchema)
                        return [2 /*return*/, executeSchemaValidation(fields)];
                    if (!Array.isArray(fields)) return [3 /*break*/, 2];
                    return [4 /*yield*/, Promise.all(fields.map(function (data) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, executeValidation(data, false)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        }); }); }))];
                case 1:
                    result = _a.sent();
                    reRenderForm({});
                    return [2 /*return*/, result.every(Boolean)];
                case 2: return [2 /*return*/, executeValidation(fields)];
            }
        });
    }); }, [executeSchemaValidation, executeValidation, validationSchema]);
    var setValue = useCallback(function (name, value, shouldValidate) {
        if (shouldValidate === void 0) { shouldValidate = false; }
        setValueInternal(name, value);
        if (shouldValidate)
            triggerValidation({ name: name });
    }, [setValueInternal, triggerValidation]);
    validateAndStateUpdateRef.current = validateAndStateUpdateRef.current
        ? validateAndStateUpdateRef.current
        : function (_a) {
            var name = _a.target.name, type = _a.type;
            return __awaiter(_this, void 0, void 0, function () {
                var fields, errorsFromRef, ref, isBlurType, isValidateDisabled, shouldUpdateValidateMode, shouldUpdateState, result, fieldsErrors, error, shouldUpdate, error, shouldUpdate;
                var _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (Array.isArray(validationFields) && !validationFields.includes(name))
                                return [2 /*return*/];
                            fields = fieldsRef.current;
                            errorsFromRef = errorsRef.current;
                            ref = fields[name];
                            if (!ref)
                                return [2 /*return*/];
                            isBlurType = type === 'blur';
                            isValidateDisabled = !isSubmittedRef.current && isOnSubmit;
                            shouldUpdateValidateMode = isOnChange || (isOnBlur && isBlurType);
                            shouldUpdateState = isWatchAllRef.current || watchFieldsRef.current[name];
                            if (!isDirtyRef.current) {
                                isDirtyRef.current = true;
                                shouldUpdateState = true;
                            }
                            if (!touchedFieldsRef.current.has(name)) {
                                touchedFieldsRef.current.add(name);
                                shouldUpdateState = true;
                            }
                            if (isValidateDisabled && shouldUpdateState)
                                return [2 /*return*/, reRenderForm({})];
                            if (!validationSchema) return [3 /*break*/, 2];
                            result = getFieldsValue(fields);
                            return [4 /*yield*/, validateWithSchema(validationSchema, result)];
                        case 1:
                            fieldsErrors = _c.sent();
                            isSchemaValidateTriggeredRef.current = true;
                            error = fieldsErrors[name];
                            shouldUpdate = ((!error && errorsFromRef[name]) || error) &&
                                (shouldUpdateValidateMode || isSubmittedRef.current);
                            if (shouldUpdate) {
                                errorsRef.current = __assign({}, errorsFromRef, (_b = {}, _b[name] = error, _b));
                                if (!error)
                                    delete errorsRef.current[name];
                                return [2 /*return*/, reRenderForm({})];
                            }
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, validateField(ref, fields, nativeValidation)];
                        case 3:
                            error = _c.sent();
                            shouldUpdate = shouldUpdateWithError({
                                errors: errorsFromRef,
                                error: error,
                                isValidateDisabled: isValidateDisabled,
                                isOnBlur: isOnBlur,
                                isBlurType: isBlurType,
                                name: name,
                            });
                            if (shouldUpdate || shouldUpdateValidateMode) {
                                errorsRef.current = combineErrorsRef(error);
                                if (renderBaseOnError(name, errorsRef.current, error))
                                    return [2 /*return*/];
                            }
                            _c.label = 4;
                        case 4:
                            if (shouldUpdateState)
                                reRenderForm({});
                            return [2 /*return*/];
                    }
                });
            });
        };
    var removeEventListener = useCallback(findRemovedFieldAndRemoveListener.bind(null, fieldsRef.current, touchedFieldsRef, fieldsWithValidationRef, validateAndStateUpdateRef.current), []);
    var clearError = function (name) {
        if (name === undefined) {
            errorsRef.current = {};
        }
        else if (isString(name)) {
            delete errorsRef.current[name];
        }
        else if (Array.isArray(name)) {
            name.forEach(function (item) {
                delete errorsRef.current[item];
            });
        }
        reRenderForm({});
    };
    var setError = function (name, type, message, ref) {
        var errorsFromRef = errorsRef.current;
        var error = errorsFromRef[name];
        var isSameError = error &&
            !isString(error) &&
            (error.type === type && error.message === message);
        if (!isSameError) {
            errorsFromRef[name] = {
                type: type,
                message: message,
                ref: ref,
                isManual: true,
            };
            reRenderForm({});
        }
    };
    var registerIntoFieldsRef = useCallback(function (elementRef, data) {
        if (elementRef && !elementRef.name)
            return warnMessage("\u26A0 Missing field name: " + elementRef);
        var name = elementRef.name, type = elementRef.type, value = elementRef.value;
        if (!isOnSubmit && data && !isEmptyObject(data)) {
            fieldsWithValidationRef.current.add(name);
        }
        var _a = data || {}, _b = _a.required, required = _b === void 0 ? false : _b, _c = _a.validate, validate = _c === void 0 ? undefined : _c;
        var inputData = __assign({}, data, { ref: elementRef });
        var fields = fieldsRef.current;
        var isRadio = isRadioInput(type);
        var field = fields[name];
        var existRadioOptionIndex = isRadio && field && Array.isArray(field.options)
            ? field.options.findIndex(function (_a) {
                var ref = _a.ref;
                return value === ref.value;
            })
            : -1;
        if ((!isRadio && field) || (isRadio && existRadioOptionIndex > -1))
            return;
        if (!type) {
            fields[name] = __assign({ ref: { name: name } }, data);
        }
        else {
            if (isRadio) {
                if (!field)
                    fields[name] = {
                        options: [],
                        required: required,
                        validate: validate,
                        ref: { type: 'radio', name: name },
                    };
                if (validate)
                    fields[name].validate = validate;
                (fields[name].options || []).push(__assign({}, inputData, { mutationWatcher: onDomRemove(elementRef, function () { return removeEventListener(inputData, true); }) }));
            }
            else {
                fields[name] = __assign({}, inputData, { mutationWatcher: onDomRemove(elementRef, function () { return removeEventListener(inputData, true); }) });
            }
        }
        if (defaultValues) {
            var defaultValue = defaultValues[name] || get(defaultValues, name);
            if (defaultValue !== undefined)
                setFieldValue(name, defaultValue);
        }
        if (!type)
            return;
        var fieldData = isRadio
            ? (fields[name].options || [])[(fields[name].options || []).length - 1]
            : fields[name];
        if (!fieldData)
            return;
        if (nativeValidation && data) {
            attachNativeValidation(elementRef, data);
        }
        else {
            attachEventListeners({
                field: fieldData,
                isRadio: isRadio,
                validateAndStateUpdate: validateAndStateUpdateRef.current,
            });
        }
    }, [defaultValues, isOnSubmit, nativeValidation, removeEventListener]);
    function watch(fieldNames, defaultValue) {
        var fieldValues = getFieldsValue(fieldsRef.current);
        var watchFields = watchFieldsRef.current;
        if (isString(fieldNames)) {
            var value = assignWatchFields(fieldValues, fieldNames, watchFields);
            if (!isUndefined(value)) {
                return value;
            }
            else if (!isUndefined(defaultValue)) {
                return defaultValue;
            }
            return getDefaultValue(defaultValues, fieldNames);
        }
        if (Array.isArray(fieldNames)) {
            return isEmptyObject(fieldsRef.current)
                ? fieldNames.reduce(function (previous, name) {
                    var _a;
                    return (__assign({}, previous, (_a = {}, _a[name] = !isUndefined(defaultValue) && !isString(defaultValue)
                        ? defaultValue[name]
                        : undefined, _a)));
                }, {})
                : fieldNames.reduce(function (previous, name) {
                    var _a;
                    return (__assign({}, previous, (_a = {}, _a[name] = assignWatchFields(fieldValues, name, watchFields) ||
                        getDefaultValue(defaultValues, name), _a)));
                }, {});
        }
        return fieldValues || defaultValue || defaultValues;
    }
    var register = useCallback(function (refOrValidateRule, validateRule) {
        if (!refOrValidateRule || typeof window === 'undefined')
            return;
        if (validateRule && !refOrValidateRule.name) {
            warnMessage(refOrValidateRule);
            return;
        }
        if (refOrValidateRule.name) {
            registerIntoFieldsRef(refOrValidateRule, validateRule);
        }
        return function (ref) {
            return ref && registerIntoFieldsRef(ref, refOrValidateRule);
        };
    }, [registerIntoFieldsRef]);
    var resetField = function (name) {
        var field = fieldsRef.current[name];
        if (!field)
            return;
        var ref = field.ref, options = field.options;
        isRadioInput(ref.type) && Array.isArray(options)
            ? options.forEach(function (input) { return removeEventListener(input, true); })
            : removeEventListener(ref, true);
        delete watchFieldsRef.current[name];
        delete errorsRef.current[name];
        delete fieldsRef.current[name];
        touchedFieldsRef.current.delete(name);
        fieldsWithValidationRef.current.delete(name);
        validFieldsRef.current.delete(name);
    };
    var unregister = function (name) {
        Array.isArray(name) ? name.forEach(resetField) : resetField(name);
    };
    var handleSubmit = function (callback) { return function (e) { return __awaiter(_this, void 0, void 0, function () {
        var fieldErrors, fieldValues, firstFocusError, fields, currentFieldValues, _a, errors, values;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (e && !nativeValidation) {
                        e.preventDefault();
                        e.persist();
                    }
                    firstFocusError = true;
                    fields = fieldsRef.current;
                    currentFieldValues = validationFields
                        ? validationFields.map(function (name) { return fieldsRef.current[name]; })
                        : Object.values(fields);
                    isSubmittingRef.current = true;
                    reRenderForm({});
                    if (!validationSchema) return [3 /*break*/, 2];
                    fieldValues = getFieldsValue(fields);
                    return [4 /*yield*/, validateWithSchema(validationSchema, fieldValues)];
                case 1:
                    fieldErrors = _b.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, currentFieldValues.reduce(function (previous, field) { return __awaiter(_this, void 0, void 0, function () {
                        var resolvedPrevious, ref, name, fieldError;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!field)
                                        return [2 /*return*/, previous];
                                    return [4 /*yield*/, previous];
                                case 1:
                                    resolvedPrevious = _a.sent();
                                    ref = field.ref, name = field.ref.name;
                                    if (!fields[name])
                                        return [2 /*return*/, Promise.resolve(resolvedPrevious)];
                                    return [4 /*yield*/, validateField(field, fields, nativeValidation)];
                                case 2:
                                    fieldError = _a.sent();
                                    if (fieldError[name]) {
                                        if (submitFocusError && firstFocusError && ref.focus) {
                                            ref.focus();
                                            firstFocusError = false;
                                        }
                                        resolvedPrevious.errors = __assign({}, (resolvedPrevious.errors || {}), fieldError);
                                        return [2 /*return*/, Promise.resolve(resolvedPrevious)];
                                    }
                                    resolvedPrevious.values[name] = getFieldValue(fields, ref);
                                    return [2 /*return*/, Promise.resolve(resolvedPrevious)];
                            }
                        });
                    }); }, Promise.resolve({
                        errors: {},
                        values: {},
                    }))];
                case 3:
                    _a = _b.sent(), errors = _a.errors, values = _a.values;
                    fieldErrors = errors;
                    fieldValues = values;
                    _b.label = 4;
                case 4:
                    if (!isEmptyObject(fieldErrors)) return [3 /*break*/, 6];
                    errorsRef.current = {};
                    return [4 /*yield*/, callback(combineFieldValues(fieldValues), e)];
                case 5:
                    _b.sent();
                    return [3 /*break*/, 7];
                case 6:
                    errorsRef.current = fieldErrors;
                    _b.label = 7;
                case 7:
                    if (isUnMount.current)
                        return [2 /*return*/];
                    isSubmittedRef.current = true;
                    submitCountRef.current += 1;
                    isSubmittingRef.current = false;
                    reRenderForm({});
                    return [2 /*return*/];
            }
        });
    }); }; };
    var resetRefs = function () {
        watchFieldsRef.current = {};
        errorsRef.current = {};
        isWatchAllRef.current = false;
        isSubmittedRef.current = false;
        isDirtyRef.current = false;
        touchedFieldsRef.current = new Set();
        fieldsWithValidationRef.current = new Set();
        validFieldsRef.current = new Set();
        submitCountRef.current = 0;
        isSchemaValidateTriggeredRef.current = false;
    };
    var unSubscribe = useCallback(function () {
        fieldsRef.current &&
            Object.values(fieldsRef.current).forEach(function (field) {
                if (!field)
                    return;
                var ref = field.ref, options = field.options;
                isRadioInput(ref.type) && Array.isArray(options)
                    ? options.forEach(function (fieldRef) {
                        return removeEventListener(fieldRef, true);
                    })
                    : removeEventListener(field, true);
            });
        fieldsRef.current = {};
        resetRefs();
    }, [removeEventListener]);
    var reset = useCallback(function (values) {
        var e_1, _a;
        var fields = Object.values(fieldsRef.current);
        try {
            for (var fields_1 = __values(fields), fields_1_1 = fields_1.next(); !fields_1_1.done; fields_1_1 = fields_1.next()) {
                var field = fields_1_1.value;
                if (field && field.ref.closest) {
                    field.ref.closest('form').reset();
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (fields_1_1 && !fields_1_1.done && (_a = fields_1.return)) _a.call(fields_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        resetRefs();
        if (values) {
            Object.entries(values).forEach(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                setFieldValue(key, value);
            });
        }
        reRenderForm({});
    }, []);
    var getValues = function (payload) {
        var data = getFieldsValue(fieldsRef.current);
        return payload && payload.nest ? combineFieldValues(data) : data;
    };
    useEffect(function () {
        return function () {
            isUnMount.current = true;
            unSubscribe();
        };
    }, [unSubscribe]);
    var isEmptyErrors = isEmptyObject(errorsRef.current);
    return {
        register: register,
        unregister: unregister,
        handleSubmit: handleSubmit,
        watch: watch,
        unSubscribe: unSubscribe,
        reset: reset,
        clearError: clearError,
        setError: setError,
        setValue: setValue,
        triggerValidation: triggerValidation,
        getValues: getValues,
        errors: errorsRef.current,
        formState: __assign({ dirty: isDirtyRef.current, isSubmitted: isSubmittedRef.current, submitCount: submitCountRef.current, touched: __spread(touchedFieldsRef.current), isSubmitting: isSubmittingRef.current }, (isOnSubmit
            ? {
                isValid: isEmptyErrors,
            }
            : {
                isValid: validationSchema
                    ? isSchemaValidateTriggeredRef.current && isEmptyErrors
                    : fieldsWithValidationRef.current.size
                        ? !isEmptyObject(fieldsRef.current) &&
                            validFieldsRef.current.size >=
                                fieldsWithValidationRef.current.size
                        : !isEmptyObject(fieldsRef.current),
            })),
    };
}

var FormGlobalContext = createContext({});
var useFormContext = function () {
    return useContext(FormGlobalContext);
};
function FormContext(props) {
    var children = props.children, rest = __rest(props, ["children"]);
    return (createElement(FormGlobalContext.Provider, { value: __assign({}, rest) }, children));
}

export default useForm;
export { FormContext, useFormContext };
